Index: src/isdn/Q921.c
===================================================================
--- src/isdn/Q921.c	(revision 495)
+++ src/isdn/Q921.c	(working copy)
@@ -37,12 +37,247 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 *****************************************************************************/
-#include "Q921.h"
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
+#include <stdarg.h>
+
+#include "Q921.h"
 #include "mfifo.h"
 
+
+/*
+ * Declarations
+ */
 int Q921SendRR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf);
+int Q921ProcIFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+int Q921ProcSFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+int Q921ProcUFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+
+int Q921SetReceiverBusy(L2TRUNK trunk);
+int Q921ClearReceiverBusy(L2TRUNK trunk);
+
+static int Q921TeiSendAssignRequest(L2TRUNK trunk);
+static int Q921TeiProcAssignResponse(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+static int Q921TeiSendVerifyRequest(L2TRUNK trunk);
+static int Q921TeiProcCheckRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+static int Q921TeiProcRemoveRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+static int Q921TeiProcAssignRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+static int Q921TeiProcCheckResponse(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+static int Q921TeiProcVerifyRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size);
+static int Q921TeiSendRemoveRequest(L2TRUNK trunk, L2UCHAR tei);
+/* unused for now
+ *static int Q921TeiSendDenyResponse(L2TRUNK trunk, L2UCHAR tei, L2USHORT ri);
+ *static int Q921TeiSendAssignedResponse(L2TRUNK trunk, L2UCHAR tei, L2USHORT ri);
+ *static int Q921TeiSendCheckRequest(L2TRUNK trunk, L2UCHAR tei);
+ */
+
+
+/*
+ * Logging
+ */
+static int Q921Log(L2TRUNK trunk, Q921LogLevel_t level, const char *fmt, ...);
+static int Q921LogMesg(L2TRUNK trunk, Q921LogLevel_t level, L2UCHAR received, L2UCHAR *mes, L2INT size, const char *fmt, ...);
+
+/*
+ * State handling
+ */
+static int Q921ChangeState(L2TRUNK trunk, Q921State_t state);
+
+
+/******************************************************************************************************
+ * Actual code below this line
+ ******************************************************************************************************/
+
+
+/**
+ * Q921StateNames
+ * \brief	Static array of state name / value mappings
+ */
+static struct Q921StateName {
+	Q921State_t value;
+	const char *name;
+} Q921StateNames[10] = {
+	{ Q921_STATE_STOPPED, "Stopped" },
+	{ Q921_STATE_TEI_UNASSIGNED, "TEI Unassigned" },
+	{ Q921_STATE_TEI_AWAITING, "TEI Awaiting Assignment" },
+	{ Q921_STATE_TEI_ESTABLISH, "TEI Awaiting Establishment" },
+	{ Q921_STATE_TEI_ASSIGNED, "TEI Assigned" },
+	{ Q921_STATE_AWAITING_ESTABLISHMENT, "Awaiting Establishment" },
+	{ Q921_STATE_AWAITING_RELEASE, "Awaiting Release" },
+	{ Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, "Multiple Frame Mode Established" },
+	{ Q921_STATE_TIMER_RECOVERY, "Timer Recovery" },
+	{ 0, 0 }
+};
+
+/**
+ * Q921State2Name
+ * \brief	Convert state value to name
+ * \param[in]	state	the state value
+ * \return	the state name or "Unknown"
+ *
+ * \author	Stefan Knoblich
+ */
+static const char *Q921State2Name(Q921State_t state)
+{
+	struct Q921StateName *p = Q921StateNames;
+
+	while(p->name) {
+		if(p->value == state)
+			return p->name;
+		p++;
+	}
+
+	return "Unknown";
+}
+
+
+/**
+ * Q921SendEnquiry
+ */
+int Q921SendEnquiry(L2TRUNK trunk, L2UCHAR tei)
+{
+	/* send enquiry: begin */
+	if(Q921_CHECK_FLAG(trunk, Q921_FLAG_RECV_BUSY)) {
+
+		Q921SendRNR(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 1);
+	}
+	else {
+		Q921SendRR(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 1);
+	}
+
+	/* clear acknowledge pending */
+	Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+
+	/* "Start" T200 */
+	Q921T200TimerReset(trunk, tei);
+
+	/* send enquiry: end */
+	return 1;
+}
+
+/**
+ * Q921SendEnquiryResponse
+ */
+int Q921SendEnquiryResponse(L2TRUNK trunk, L2UCHAR tei)
+{
+	/* send enquiry: begin */
+	if(Q921_CHECK_FLAG(trunk, Q921_FLAG_RECV_BUSY)) {
+
+		Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+	}
+	else {
+		Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+		/* clear acknowledge pending */
+		Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+	}
+	/* send enquiry: end */
+	return 1;
+}
+
+/**
+ * Q921ResetExceptionConditions
+ * \brief	Reset Q.921 Exception conditions procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \todo	Do something
+ */
+void Q921ResetExceptionConditions(L2TRUNK trunk, L2UCHAR tei)
+{
+	/* Clear peer receiver busy */
+	Q921_CLEAR_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY);
+
+	/* Clear reject exception */
+	Q921_CLEAR_FLAG(trunk, Q921_FLAG_REJECT);
+
+	/* Clear own receiver busy */
+	Q921_CLEAR_FLAG(trunk, Q921_FLAG_RECV_BUSY);
+
+	/* Clear acknowledge pending */
+	Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+
+	return;
+}
+
+/**
+ * Q921EstablishDataLink
+ * \brief	Q.921 Establish data link procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \return	always 1 (success)
+ */
+int Q921EstablishDataLink(L2TRUNK trunk, L2UCHAR tei)
+{
+	L2UCHAR idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	/* reset exception conditions */
+	Q921ResetExceptionConditions(trunk, tei);
+
+	/* RC = 0 */
+	trunk->N200[idx] = 0;
+
+	/* Send SABME */
+	Q921SendSABME(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 1);
+
+	/* Restart T200, stop T203 */
+	Q921T200TimerReset(trunk, tei);
+	Q921T203TimerStop(trunk, tei);
+
+	return 1;
+}
+
+/**
+ * Q921NrErrorRecovery
+ * \brief	NR(R) Error recovery procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \return	always 1 (success)
+ */
+int Q921NrErrorRecovery(L2TRUNK trunk, L2UCHAR tei)
+{
+	/* MDL Error indication (J) */
+
+	/* Establish datalink */
+	Q921EstablishDataLink(trunk, tei);
+
+	/* Clear L3 initiated */
+	Q921_CLEAR_FLAG(trunk, Q921_FLAG_L3_INITIATED);
+
+	return 1;
+}
+
+
+/**
+ * Q921InvokeRetransmission
+ * \brief	I Frame retransmission procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \param	nr	N(R) for retransmission
+ * \return	always 1 (success)
+ */
+int Q921InvokeRetransmission(L2TRUNK trunk, L2UCHAR tei, L2UCHAR nr)
+{
+	L2UCHAR idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+#if __TODO__
+	while(trunk->vs[idx] != nr) {	/* ???? */
+		/* V(S) = V(S) - 1 */
+		Q921_DEC_COUNTER(trunk->vs[idx]);
+
+		/* <- I Frame queued up (move I frame to tx queue? */
+
+		/* next frame in queue (backtrack along I queue) ??? */
+	}
+#endif
+	return 1;
+}
+
 
 /*****************************************************************************
 
@@ -56,43 +291,364 @@
 					L2UCHAR sapi,
 					L2UCHAR tei,
 					Q921NetUser_t NetUser,
+					Q921NetType_t NetType,
 					L2INT hsize,
-					Q921TxCB_t cb21,
-					Q921TxCB_t cb23,
+					Q921Tx21CB_t cb21,
+					Q921Tx23CB_t cb23,
 					void *priv21,
 					void *priv23)
 {
 	if (trunk->initialized != INITIALIZED_MAGIC) {
 		MFIFOCreate(trunk->HDLCInQueue, Q921MAXHDLCSPACE, 10);
+
+		/* Initialize I + UI queue */
+		MFIFOCreate(trunk->UIFrameQueue, Q921MAXHDLCSPACE, 10);
+		MFIFOCreate(trunk->IFrameQueue, Q921MAXHDLCSPACE, 10);
+
 		trunk->initialized = INITIALIZED_MAGIC;
 	}
-	trunk->va = 0;
-	trunk->vs = 0;	
-	trunk->vr = 0;
-	trunk->state = 0;
+
+	trunk->state = Q921_STATE_STOPPED;
+	trunk->flags = 0;
 	trunk->sapi = sapi;
 	trunk->tei = tei;
 	trunk->NetUser = NetUser;
+	trunk->NetType = NetType;
 	trunk->Q921Tx21Proc = cb21;
 	trunk->Q921Tx23Proc = cb23;
 	trunk->PrivateData21 = priv21;
 	trunk->PrivateData23 = priv23;
 	trunk->Q921HeaderSpace = hsize;
-	trunk->T200 = 0;
-	trunk->T203 = 0;
-	trunk->T200Timeout = 1000;
-	trunk->T203Timeout = 10000;
+
+	/* timeout default values */
+	trunk->T200Timeout = 1000;	/*   1 second  */
+	trunk->T203Timeout = 10000;	/*  10 seconds */
+	trunk->T202Timeout = 2000;	/*   2 seconds */
+	trunk->T201Timeout = 200000;	/* 200 seconds */
+
+	/* octet / retransmit counter default limits */
+	trunk->N200Limit   = 3;		/*   3 retransmits */
+	trunk->N201Limit   = 260;	/* 260 octets      */
+	trunk->N202Limit   = 3;		/*   3 retransmits */
+
+	/* reset counters, timers, etc. */
+	trunk->T202 = 0;
+	trunk->N202 = 0;
+
+	memset(trunk->T200, 0, sizeof(*trunk->T200)*Q921_TEI_MAX);
+	memset(trunk->T201, 0, sizeof(*trunk->T201)*Q921_TEI_MAX);
+	memset(trunk->T203, 0, sizeof(*trunk->T203)*Q921_TEI_MAX);
+	memset(trunk->N200, 0, sizeof(*trunk->N200)*Q921_TEI_MAX);
+
+	memset(trunk->ri, 0, sizeof(*trunk->ri)*Q921_TEI_MAX);
+	memset(trunk->va, 0, sizeof(*trunk->va)*Q921_TEI_MAX);
+	memset(trunk->vs, 0, sizeof(*trunk->vs)*Q921_TEI_MAX);
+	memset(trunk->vr, 0, sizeof(*trunk->vr)*Q921_TEI_MAX);
+
+	if(Q921_IS_PTMP(trunk)) {
+		/*
+		 * Clear list of assigned TEIs, send TEI reset command
+		 */
+		trunk->tei = 0;
 }
+}
+
 
+/**
+ * Q921Tx21Proc
+ * \brief	Submit frame to layer 1 (for sending)
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ */
 int Q921Tx21Proc(L2TRUNK trunk, L2UCHAR *Msg, L2INT size)
 {
+	Q921LogMesg(trunk, Q921_LOG_DEBUG, 0, Msg, size, "Sending frame\n");
+
 	return trunk->Q921Tx21Proc(trunk->PrivateData21, Msg, size);
 }
 
-int Q921Tx23Proc(L2TRUNK trunk, L2UCHAR *Msg, L2INT size)
+
+/**
+ * Q921Tx23Proc
+ * \brief	Submit frame to layer 3
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ */
+int Q921Tx23Proc(L2TRUNK trunk, Q921DLMsg_t ind, L2UCHAR *Msg, L2INT size)
+{
+	return trunk->Q921Tx23Proc(trunk->PrivateData23, ind, Msg, size);
+}
+
+
+/**
+ * Q921LogProc
+ * \brief	Used for logging, converts to string and submits to higher level log function via callback
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	level	Q921 Loglevel
+ * \param[in]	fmt	format of logmessage
+ * \return	>= 0 on success, < 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921Log(L2TRUNK trunk, Q921LogLevel_t level, const char *fmt, ...)
+{
+	char  buf[Q921_LOGBUFSIZE];
+	L2INT len;
+	va_list ap;
+
+	if(!trunk->Q921LogProc)
+		return 0;
+
+	if(trunk->loglevel < level)
+		return 0;
+
+	va_start(ap, fmt);
+
+	len = vsnprintf(buf, sizeof(buf)-1, fmt, ap);
+	if(len <= 0) {
+		/* TODO: error handling */
+		return -1;
+	}
+
+	va_end(ap);
+
+	return trunk->Q921LogProc(trunk->PrivateDataLog, level, buf, strnlen(buf, sizeof(buf)-1));
+}
+
+
+/**
+ * Q921LogProcMesg
+ * \brief	Used for logging, converts to string and submits to higher level log function via callback
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	level	Q921 Loglevel
+ * \param[in]	received	direction of the message (received = 1, sending = 0)
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \param[in]	fmt	format of logmessage
+ * \return	>= 0 on success, < 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921LogMesg(L2TRUNK trunk, Q921LogLevel_t level, L2UCHAR received, L2UCHAR *mes, L2INT size, const char *fmt, ...)
 {
-	return trunk->Q921Tx23Proc(trunk->PrivateData23, Msg, size);
+	char  buf[Q921_LOGBUFSIZE];
+	L2INT len, left;
+	va_list ap;
+
+	if(!trunk->Q921LogProc)
+		return 0;
+
+	if(trunk->loglevel < level)
+		return 0;
+
+	if(!mes)
+		return 0;
+
 
+	left = sizeof(buf) - 1;
+
+	va_start(ap, fmt);
+
+	len = vsnprintf(buf, left, fmt, ap);
+	if(len > 0)
+		left -= len;
+	else {
+		/* TODO: error handling */
+		return -1;
+	}
+
+	va_end(ap);
+
+	if(trunk->loglevel == Q921_LOG_DEBUG) {
+		char pbuf[1024];
+		L2INT pleft, poffset;
+		L2UCHAR sapi, tei, cr;
+		L2UCHAR *pmes = mes + trunk->Q921HeaderSpace;
+		L2INT idx;
+
+		pleft   = sizeof(pbuf);
+		poffset = 0;
+
+		/*
+		 * Decode packet
+		 */
+		sapi = (pmes[0] & 0xfc) >> 2;
+		cr   = (pmes[0] & 0x02) >> 1;
+		tei  = (pmes[1] & 0xfe) >> 1;
+		idx  = Q921_IS_PTMP_NT(trunk) ? tei : 0;
+
+		/* make cr actually useful */
+		cr   = (received) ? Q921_IS_COMMAND(trunk, cr) : Q921_IS_RESPONSE(trunk, cr);
+
+		len = snprintf(pbuf + poffset, pleft, "\n----------------- Q.921 Packet ---------------\n");
+		if(len > 0) {
+			poffset += len;
+			pleft   -= len;
+		} else {
+			goto out;			
+		}
+
+		/* common header */
+		len = snprintf(pbuf + poffset, pleft, "    SAPI: %u, TEI: %u, C/R: %s (%d)\n\n", sapi, tei, (cr) ? "Command" : "Response", (mes[0] & 0x02) >> 1 );
+		if(len > 0) {
+			poffset += len;
+			pleft   -= len;
+		} else
+			goto out;
+
+		/*
+		 * message specific
+		 */
+		if((pmes[2] & 0x01) == 0x00) {
+			/*
+			 * I frame
+			 */
+			L2UCHAR pf = pmes[3] & 0x01;	/* poll / final flag */
+			L2UCHAR nr = pmes[3] >> 1;	/* receive sequence number */
+			L2UCHAR ns = pmes[2] >> 1;	/* send sequence number */
+
+			len = snprintf(pbuf + poffset, pleft, "    Type: I Frame\n          P/F: %d, N(S): %d, N(R): %d  [V(A): %d, V(R): %d, V(S): %d]\n", pf, ns, nr,
+														trunk->va[idx], trunk->vr[idx], trunk->vs[idx]);
+			if(len > 0) {
+				poffset += len;
+				pleft   -= len;
+			} else
+				goto out;
+		}
+		else if((pmes[2] & 0x03) == 0x01) {
+			/*
+			 * S frame
+			 */
+			L2UCHAR sv = (pmes[2] & 0x0c) >> 2;	/* supervisory format id */
+			L2UCHAR pf = pmes[3] & 0x01;		/* poll / final flag */
+			L2UCHAR nr = pmes[3] >> 1;		/* receive sequence number */
+			const char *type;
+
+			switch(sv) {
+			case 0x00:	/* RR : Receive Ready */
+				type = "RR (Receive Ready)";
+				break;
+
+			case 0x02:	/* RNR : Receive Not Ready */
+				type = "RNR (Receiver Not Ready)";
+				break;
+
+			case 0x04:	/* REJ : Reject */
+				type = "REJ (Reject)";
+				break;
+
+			default:	/* Invalid / Unknown */
+				type = "Unknown";
+				break;
+			}
+
+			len = snprintf(pbuf + poffset, pleft, "    Type: S Frame, SV: %s\n          P/F: %d, N(R): %d  [V(A): %d, V(R): %d, V(S): %d]\n", type, pf, nr,
+														trunk->va[idx], trunk->vr[idx], trunk->vs[idx]);
+			if(len > 0) {
+				poffset += len;
+				pleft   -= len;
+			} else
+				goto out;
+		}
+		else if((pmes[2] & 0x03) == 0x03) {
+			/*
+			 * U frame
+			 */
+			L2UCHAR m  = (pmes[2] & 0xe0) >> 3 | (pmes[2] & 0x0c) >> 2;	/* modifier function id */
+			L2UCHAR pf = (pmes[2] & 0x10) >> 4;				/* poll / final flag */
+			const char *type;
+
+			switch(m) {
+			case 0x00:
+				type = "UI (Unnumbered Information)";
+				break;
+
+			case 0x03:
+				type = "DM (Disconnected Mode)";
+				break;
+
+			case 0x08:
+				type = "DISC (Disconnect)";
+				break;
+
+			case 0x0c:
+				type = "UA (Unnumbered Acknowledgement)";
+				break;
+
+			case 0x0f:
+				type = "SABME";
+				break;
+
+			case 0x11:
+				type = "FRMR (Frame Reject)";
+				break;
+
+			case 0x17:
+				type = "XID (Exchange Identification)";
+				break;
+
+			default:
+				type = "Unknown";
+			}
+
+
+			len = snprintf(pbuf + poffset, pleft, "    Type: U Frame (%s)\n          P/F: %d\n", type, pf);
+			if(len > 0) {
+				poffset += len;
+				pleft   -= len;
+			} else
+				goto out;
+		}	
+		else {
+			/*
+			 * Unknown
+			 */
+			strncat(pbuf + poffset, "  -- unknown frame type --\n", pleft);
+
+			len = (sizeof(pbuf) - poffset) - strlen(pbuf + poffset);
+			if(len > 0) {
+				poffset += len;
+				pleft   -= len;
+			} else
+				goto out;
+		}
+
+		len = snprintf(pbuf + poffset, pleft, "\n    Q.921 state: \"%s\" (%d) [flags: %c%c%c%c]\n", Q921State2Name(trunk->state), trunk->state,
+											Q921_CHECK_FLAG(trunk, Q921_FLAG_ACK_PENDING) ? 'A' : '-',
+											Q921_CHECK_FLAG(trunk, Q921_FLAG_REJECT) ? 'R' : '-',
+											Q921_CHECK_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY) ? 'P' : '-',
+											Q921_CHECK_FLAG(trunk, Q921_FLAG_RECV_BUSY) ? 'B' : '-');
+		if(len > 0) {
+			poffset += len;
+			pleft   -= len;
+		} else
+			goto out;
+
+
+		strncat(pbuf + poffset, "----------------------------------------------\n\n", pleft);
+
+		len = (sizeof(pbuf) - poffset) - strlen(pbuf + poffset);
+		if(len > 0) {
+			poffset += len;
+			pleft   -= len;
+		} else
+			goto out;
+
+
+		/* concat buffers together */
+		len = strlen(pbuf);
+		if(len <= left)
+			strncat(buf, pbuf, left);
+		else
+			strncat(buf, "-- packet truncated --\n", left);
+	}
+
+out:
+	return trunk->Q921LogProc(trunk->PrivateDataLog, level, buf, strlen(buf));
 }
 
 /*****************************************************************************
@@ -111,7 +667,8 @@
 L2ULONG Q921GetTime(void)
 {
     L2ULONG tNow = 0;
-    if(Q921GetTimeProc != NULL)
+
+	if(Q921GetTimeProc)
     {
         tNow = Q921GetTimeProc();
         if(tNow < tLast)    /* wrapped */
@@ -123,64 +680,353 @@
     return tNow;
 }
 
-void Q921T200TimerStart(L2TRUNK trunk)
+/*
+ * T200 handling (per-TEI in PTMP NT mode, tei=0 otherwise)
+ */
+void Q921T200TimerStart(L2TRUNK trunk, L2UCHAR tei)
+{
+	if(!Q921_IS_PTMP_NT(trunk))
+		tei = 0;
+
+	if (!trunk->T200[tei]) {
+		trunk->T200[tei] = Q921GetTime() + trunk->T200Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T200 started\n");
+	}
+}
+
+void Q921T200TimerStop(L2TRUNK trunk, L2UCHAR tei)
+{
+	if(!Q921_IS_PTMP_NT(trunk))
+		tei = 0;
+
+	trunk->T200[tei] = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T200 stopped\n");
+}
+
+void Q921T200TimerReset(L2TRUNK trunk, L2UCHAR tei)
+{
+	if(!Q921_IS_PTMP_NT(trunk))
+		tei = 0;
+
+	trunk->T200[tei] = Q921GetTime() + trunk->T200Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T200 restarted\n");
+}
+
+/*
+ * T203 handling (per-TEI in PTMP NT mode, tei=0 otherwise)
+ */
+void Q921T203TimerStart(L2TRUNK trunk, L2UCHAR tei)
+{
+	if(!Q921_IS_PTMP_NT(trunk))
+		tei = 0;
+
+	if (!trunk->T203[tei]) {
+		trunk->T203[tei] = Q921GetTime() + trunk->T203Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T203 started\n");
+	}
+}
+
+void Q921T203TimerStop(L2TRUNK trunk, L2UCHAR tei)
+{
+	if(!Q921_IS_PTMP_NT(trunk))
+		tei = 0;
+
+	trunk->T203[tei] = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T203 stopped\n");
+}
+
+void Q921T203TimerReset(L2TRUNK trunk, L2UCHAR tei)
+{
+	if(!Q921_IS_PTMP_NT(trunk))
+		tei = 0;
+
+	trunk->T203[tei] = Q921GetTime() + trunk->T203Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T203 restarted\n");
+}
+
+/*
+ * T202 handling (TEI message timeout, TE mode only)
+ */
+void Q921T202TimerStart(L2TRUNK trunk)
 {
-	if (!trunk->T200) {
-		trunk->T200 = Q921GetTime() + trunk->T200Timeout;
+	if (!trunk->T202) {
+		trunk->T202 = Q921GetTime() + trunk->T202Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T202 started\n");
+	}
 	}
+
+void Q921T202TimerStop(L2TRUNK trunk)
+{
+	trunk->T202 = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T202 stopped\n");
 }
 
-void Q921T200TimerStop(L2TRUNK trunk)
+void Q921T202TimerReset(L2TRUNK trunk)
 {
-	trunk->T200 = 0;
+	trunk->T202 = Q921GetTime() + trunk->T202Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T202 restarted\n");
 }
 
-void Q921T200TimerReset(L2TRUNK trunk)
+/*
+ * T201 handling (TEI management (NT side), per-TEI)
+ */
+void Q921T201TimerStart(L2TRUNK trunk, L2UCHAR tei)
 {
-	Q921T200TimerStop(trunk);
-	Q921T200TimerStart(trunk);
+	if (!trunk->T201[tei]) {
+		trunk->T201[tei] = Q921GetTime() + trunk->T201Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T201 started\n");
+	}
 }
 
-void Q921T203TimerStart(L2TRUNK trunk)
+void Q921T201TimerStop(L2TRUNK trunk, L2UCHAR tei)
 {
-	if (!trunk->T203) {
-		trunk->T203 = Q921GetTime() + trunk->T203Timeout;
+	trunk->T201[tei] = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T201 stopped\n");
 	}
+
+void Q921T201TimerReset(L2TRUNK trunk, L2UCHAR tei)
+{
+	trunk->T201[tei] = Q921GetTime() + trunk->T201Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T201 restarted\n");
 }
 
-void Q921T203TimerStop(L2TRUNK trunk)
+
+/*
+ * Expiry callbacks
+ */
+void Q921T200TimerExpire(L2TRUNK trunk, L2UCHAR tei)
 {
-	trunk->T203 = 0;
+	L2INT idx = tei;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T200 expired for TEI %d (trunk TEI %d)\n", tei, trunk->tei);
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	/* Stop timer first */
+	Q921T200TimerStop(trunk, tei);
+
+	switch(trunk->state) {
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		if(trunk->N200[idx] >= trunk->N200Limit) {
+			/* Discard I queue */
+			MFIFOClear(trunk->IFrameQueue);
+
+			/* MDL-Error indication (G) */
+			Q921Log(trunk, Q921_LOG_ERROR, "Failed to establish Q.921 link in %d retries\n", trunk->N200[idx]);
+
+			/* DL-Release indication */
+			Q921Tx23Proc(trunk, Q921_DL_RELEASE, NULL, 0);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED);
+		} else {
+			/* Increment retry counter */
+			trunk->N200[idx]++;
+
+			/* Send SABME */
+			Q921SendSABME(trunk,
+					trunk->sapi,
+					Q921_COMMAND(trunk),
+					tei,
+					1);
+
+			/* Start T200 */
+			Q921T200TimerStart(trunk, tei);
+		}
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		trunk->N200[idx] = 0;
+
+		if(!Q921_CHECK_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY)) {
+			/* get last transmitted I frame */
+
+			/* V(S) = V(S) - 1 */
+			Q921_DEC_COUNTER(trunk->vs[idx]);
+
+			/* retransmit I frame */
+
+			/* V(S) = V(S) + 1 (done by Q921SendI() ) */
+			//trunk->vs[idx]++;
+
+			/* clear acknowledge pending */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+
+			/* Start T200 */
+			Q921T200TimerStart(trunk, tei);
+		} else {
+			/* transmit enquiry */
+			Q921SendEnquiry(trunk, tei);
+		}
+
+		/* increment counter */
+		trunk->N200[idx]++;
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_TIMER_RECOVERY);
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(trunk->N200[idx] == trunk->N200Limit) {
+			/* MDL Error indication (I) */
+
+			/* Establish data link */
+			Q921EstablishDataLink(trunk, tei);
+
+			/* Clear L3 initiated */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_L3_INITIATED);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		} else {
+			if(trunk->vs[idx] == trunk->va[idx]) {
+				/* transmit enquiry */
+				Q921SendEnquiry(trunk, tei);
+
+			} else if(!Q921_CHECK_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY)) {
+				/* get last transmitted frame */
+
+				/* V(S) = V(S) - 1 */
+				Q921_DEC_COUNTER(trunk->vs[idx]);
+
+				/* retrans frame */
+
+				/* V(S) = V(S) + 1 (done by Q921SendI() ) */
+				//Q921_INC_COUNTER(trunk->vs[idx]);
+
+				/* clear acknowledge pending */
+				Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+
+				/* Start T200 */
+				Q921T200TimerStart(trunk, tei);
+			}
+
+			/* increment counter */
+			trunk->N200[idx]++;
+
+			/* no state change */
+		}
+		break;
+
+	default:
+		break;
+	}
 }
 
-void Q921T203TimerReset(L2TRUNK trunk)
+void Q921T203TimerExpire(L2TRUNK trunk, L2UCHAR tei)
 {
-	Q921T203TimerStop(trunk);
-	Q921T203TimerStart(trunk);
+	L2INT idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T203 expired for TEI %d (trunk TEI %d)\n", tei, trunk->tei);
+
+	/* Stop Timer first */
+	Q921T203TimerStop(trunk, tei);
+
+	switch(trunk->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* Send Enquiry */
+		Q921SendEnquiry(trunk, tei);
+
+		/* RC = 0 */
+		trunk->N200[idx] = 0;
+
+		/* no state change */
+		break;
+
+	default:
+		break;
+	}
 }
 
-void Q921T200TimerExpire(L2TRUNK trunk)
+void Q921T202TimerExpire(L2TRUNK trunk)
 {
-	(void)trunk;
+	Q921T202TimerReset(trunk);
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T202 expired for Q.921 trunk with TEI %d\n", trunk->tei);
+
+	/* todo: implement resend counter */
+
+	switch(trunk->state) {
+	case Q921_STATE_TEI_ASSIGNED:	/* Tei identity verify timeout */
+		Q921TeiSendVerifyRequest(trunk);
+		break;
+
+	default:			/* Tei assignment request timeout (TODO: refine) */
+
+		if(trunk->N202 >= trunk->N202Limit) {
+			/* Too many retransmits, reset counter, stop timer and handle case (TODO) */
+			trunk->N202 = 0;
+
+			Q921T202TimerStop(trunk);
+
+			return;
 }
+		Q921TeiSendAssignRequest(trunk);
 
-void Q921T203TimerExpire(L2TRUNK trunk)
+		trunk->N202++;
+	}
+}
+
+void Q921T201TimerExpire(L2TRUNK trunk, L2UCHAR tei)
 {
-	Q921T203TimerReset(trunk);
-	Q921SendRR(trunk, trunk->sapi, trunk->NetUser == Q921_TE ? 0 : 1, trunk->tei, 1);
+	Q921Log(trunk, Q921_LOG_DEBUG, "T201 expired for TEI %d (trunk TEI: %d)\n", tei, trunk->tei);
 }
 
+/*
+ * Timer Tick function
+ */
 void Q921TimerTick(L2TRUNK trunk)
 {
 	L2ULONG tNow = Q921GetTime();
-	if (trunk->T200 && tNow > trunk->T200) {
-		Q921T200TimerExpire(trunk);
+
+	if(Q921_IS_PTMP_NT(trunk))
+	{
+		int x;
+
+		for(x=0; x<Q921_TEI_MAX; x++) {
+			/* TODO: check if TEI is assigned and skip check if not (speedup!) */
+
+			if (trunk->T200[x] && tNow > trunk->T200[x]) {
+				Q921T200TimerExpire(trunk, x);
+			}
+			if (trunk->T203[x] && tNow > trunk->T203[x]) {
+				Q921T203TimerExpire(trunk, x);		
 	}
-	if (trunk->T203 && tNow > trunk->T203) {
-		Q921T203TimerExpire(trunk);		
+			if (trunk->T201[x] && tNow > trunk->T201[x]) {
+				Q921T201TimerExpire(trunk, x);
+			}
+		}
+	} else {
+		if (trunk->T200[0] && tNow > trunk->T200[0]) {
+			Q921T200TimerExpire(trunk, trunk->tei);
+		}
+		if (trunk->T203[0] && tNow > trunk->T203[0]) {
+			Q921T203TimerExpire(trunk, trunk->tei);		
 	}
 }
 
+	if(Q921_IS_PTMP_TE(trunk)) {
+		if (trunk->T202 && tNow > trunk->T202) {
+			Q921T202TimerExpire(trunk);
+		}
+	}
+}
 
 void Q921SetGetTimeCB(L2ULONG (*callback)(void))
 {
@@ -232,24 +1078,129 @@
 *****************************************************************************/
 int Q921SendI(L2TRUNK trunk, L2UCHAR Sapi, char cr, L2UCHAR Tei, char pf, L2UCHAR *mes, L2INT size)
 {
-    mes[trunk->Q921HeaderSpace+0] = (Sapi&0xfc) | ((cr<<1)&0x02);
+	L2INT idx = (Q921_IS_PTMP_NT(trunk)) ? Tei : 0;
+
+#if 0
+	if(!Q921_IS_READY(trunk)) {
+		/* don't even bother trying */
+		return 0;
+	}
+#endif
+
+#if 0
+	if(trunk->state < Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+		/* TODO: enqueue frame and establish data-link, for now: drop it */
+
+		Q921Log(trunk, Q921_LOG_ERROR, "Dropped I frame because data-link not ready\n");
+		return 0;
+	}
+#endif
+
+	mes[trunk->Q921HeaderSpace+0] = ((Sapi<<2)&0xfc) | ((cr<<1)&0x02);
+	mes[trunk->Q921HeaderSpace+1] = (Tei<<1) | 0x01;
+	mes[trunk->Q921HeaderSpace+2] = trunk->vs[idx]<<1;
+	mes[trunk->Q921HeaderSpace+3] = (trunk->vr[idx]<<1) | (pf & 0x01);
+	trunk->vs[idx]++;
+
+	/* TODO: queueing etc. */
+	/* link not ready? enqueue I frames */
+	if(trunk->state < Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+
+		MFIFOWriteMes(trunk->IFrameQueue, mes, size);
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "I Frame of size %d bytes queued\n", size);
+		return 1;
+	}
+
+	/* Start T200, Stop T203 */
+	Q921T200TimerStart(trunk, Tei);
+	Q921T203TimerStop(trunk, Tei);
+
+	return Q921Tx21Proc(trunk, mes, size);
+}
+
+int Q921SendS(L2TRUNK trunk, L2UCHAR Sapi, char cr, L2UCHAR Tei, char pf, L2UCHAR sv, L2UCHAR *mes, L2INT size)
+{
+	L2INT idx = (Q921_IS_PTMP_NT(trunk)) ? Tei : 0;
+
+	if(!Q921_IS_READY(trunk)) {
+		/* don't even bother trying */
+		return 0;
+	}
+
+	mes[trunk->Q921HeaderSpace+0] = ((Sapi<<2)&0xfc) | ((cr<<1)&0x02);
+	mes[trunk->Q921HeaderSpace+1] = (Tei<<1) | 0x01;
+	mes[trunk->Q921HeaderSpace+2] = ((sv<<2)&0x0c) | 0x01;
+	mes[trunk->Q921HeaderSpace+3] = (trunk->vr[idx]<<1) | (pf & 0x01);
+
+	return Q921Tx21Proc(trunk, mes, size);
+}
+
+int Q921SendU(L2TRUNK trunk, L2UCHAR Sapi, char cr, L2UCHAR Tei, char pf, L2UCHAR m, L2UCHAR *mes, L2INT size)
+{
+	mes[trunk->Q921HeaderSpace+0] = ((Sapi<<2)&0xfc) | ((cr<<1)&0x02);
     mes[trunk->Q921HeaderSpace+1] = (Tei<<1) | 0x01;
-    mes[trunk->Q921HeaderSpace+2] = trunk->vs<<1;
-    mes[trunk->Q921HeaderSpace+3] = (trunk->vr<<1) | (pf & 0x01);
-    trunk->vs++;
+	mes[trunk->Q921HeaderSpace+2] = ((m<<3)&0xe0) | ((pf<<4)&0x10) | ((m<<2)&0x0c) | 0x03;
+
+	/* link not ready? enqueue non-TEI-mgmt UI frames */
+	if(m == 0x00 && mes[trunk->Q921HeaderSpace+3] != Q921_LAYER_ENT_ID_TEI && trunk->state < Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+
+		MFIFOWriteMes(trunk->UIFrameQueue, mes, size);
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "UI Frame of size %d bytes queued\n", size);
+		return 1;
+	}
 
     return Q921Tx21Proc(trunk, mes, size);
 }
 
-int Q921Rx32(L2TRUNK trunk, L2UCHAR * Mes, L2INT Size)
+int Q921Rx32(L2TRUNK trunk, Q921DLMsg_t ind, L2UCHAR * Mes, L2INT Size)
 {
-	return Q921SendI(trunk, 
+	L2INT res = 0;
+
+	/* TODO: proper queueing etc. */
+
+	switch(ind) {
+	case Q921_DL_DATA:	/* DL-DATA request */
+		if(trunk->state >= Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+			res = Q921SendI(trunk, 
 					trunk->sapi, 
-					trunk->NetUser == Q921_TE ? 0 : 1,
+					Q921_COMMAND(trunk),
 					trunk->tei, 
 					0, 
 					Mes, 
 					Size);
+		} else {
+			/* Treat as DL-ESTABLISH request */
+
+			/* queue i frame */
+			MFIFOWriteMes(trunk->IFrameQueue, Mes, Size);
+
+			/* establish data link */
+			Q921EstablishDataLink(trunk, trunk->tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	case Q921_DL_UNIT_DATA:		/* DL-UNIT DATA request */
+		if(trunk->state >= Q921_STATE_TEI_ASSIGNED) {
+			res = Q921SendUN(trunk,
+					trunk->sapi,
+					Q921_COMMAND(trunk),
+					Q921_TEI_BCAST,
+					0,
+					Mes,
+					Size);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return res;
 }
 /*****************************************************************************
 
@@ -269,14 +1220,9 @@
 
 int Q921SendRR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)0x01;
-    mes[trunk->Q921HeaderSpace+3] = (L2UCHAR)((trunk->vr<<1) | (pf & 0x01));
-
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+4);
+	return Q921SendS(trunk, Sapi, cr, Tei, pf, 0x00, mes, trunk->Q921HeaderSpace+4);
 }
 
 /*****************************************************************************
@@ -296,14 +1242,9 @@
 *****************************************************************************/
 int Q921SendRNR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
-
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)0x05;
-    mes[trunk->Q921HeaderSpace+3] = (L2UCHAR)((trunk->vr<<1) | (pf & 0x01));
+	L2UCHAR mes[25];
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+4);
+	return Q921SendS(trunk, Sapi, cr, Tei, pf, 0x01, mes, trunk->Q921HeaderSpace+4);
 }
 
 /*****************************************************************************
@@ -323,14 +1264,9 @@
 *****************************************************************************/
 int Q921SendREJ(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)0x09;
-    mes[trunk->Q921HeaderSpace+3] = (L2UCHAR)((trunk->vr<<1) | (pf & 0x01));
-
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+4);
+	return Q921SendS(trunk, Sapi, cr, Tei, pf, 0x03, mes, trunk->Q921HeaderSpace+4);
 }
 
 /*****************************************************************************
